
clear;

workDir = 'work/pump1/';
noBeatsPerBar = 4;

[musArr44100, ~] = audioread([workDir 'mus.wav']); % Stereo 44100Hz
musArr44100 = musArr44100 * 1.2;
musArr525 = decimate((musArr44100(:, 1) + musArr44100(:, 1))/2, 84); % Mono 525Hz, samme som motor
% makeClickArrKeyboard(musArr44100)
% corArrDB = makeEmptyCorArrDB(clickDBtimeMs);
% writecell(corArrDB, [workDir 'cor.xls']);
corArrDB = readcell([workDir 'cor.xls']); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
corArrDB(cellfun(@(x) any(ismissing(x)), corArrDB)) = {''}; % fix
clickDBtimeMs = cell2mat(corArrDB(:,1)); % ms, tider for DownBeat

corValArrB = makeCorValArrB(corArrDB, noBeatsPerBar, workDir); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
clickBtimeMs = corValArrB(:,1); % ms, tider for Beat

clickTrack44100 = makeClickTrack44100(clickDBtimeMs, musArr44100); % DB Klikk med lyd
wavClick44100 = clickTrack44100 + musArr44100;
%sound(wavClick44100(1:200000), 44100);

cntArr525 = makeCntArr525(corValArrB);

gu.startClickNr = 1;
gu.endClickNr = 15;
plotCurves(musArr525, corArrDB, cntArr525, clickDBtimeMs, clickBtimeMs, corValArrB, gu.startClickNr,  gu.endClickNr, workDir, 'start');

gui;


mov = iniMov(4);
plotMov(mov, 'cyc');


mov = iniMov(4);
movPop = repmat(mov,1,1,16);


gu.startClickNr = 157;
gu.endClickNr = 167;
plotCurves(musArr525, corArrDB, cntArr525, clickDBtimeMs, clickBtimeMs, corValArrB, gu.startClickNr,  gu.endClickNr, workDir, 'start');
tmpMoveName = '8-6';
movPop = iniMovPop(8, 16);
cntArr525pop = makeCntArr525pop(movPop, corArrDB, workDir, tmpMoveName);
runPreviewPOP(musArr44100, movPop, corArrDB, clickDBtimeMs, gu.startClickNr, gu.endClickNr, workDir, tmpMoveName);
 






movFileRange = [4 3 6]; % 4_1.txt til 4_4.txt
corArrDB = swapMov(corFile, '4_3', 'tmp'); % Legger inn i move "tmp" i corArrDB, modifiserer ingen bibliotek movFiles, bare tmp.txt
runPreviewPOPfromFile(musArr44100, movFileRange, corArrDB, clickDBtimeMs, 133, 150);


runDemo2(corArrDB, clickDBtimeMs, cntArr525, 1, 10);



mov = loadMovFromFile(workDir, '8-3')
mov = flipMov(mov)

saveMovToFile(mov,[workDir '8-2.txt'],workDir)

 
saveMovToFile(movGen(:,:,7), 'movIntro.txt');

writecell(corArrDB,'work/corZstd.xls');
writecell(corArrDB,'work/cor.xls');
C = readcell(filename)

saveMovToFile(mov, 'test.txt');

mov = loadMovFromFile('4-test.txt');


% EVO
% 


saveMovToFile(mov, 'movLib/movIntro.txt');
corArrDB = readcell(corFile); % DownBeat: {DBtime(ms), moveName, event, song sectionType}
corArrDB(cellfun(@(x) any(ismissing(x)), corArrDB)) = {''}; % fix
clickDBtimeMs = cell2mat(corArrDB(:,1)); % ms, tider for DownBeat
corValArrB = makeCorValArrB(corArrDB, noBeatsPerBar); % BeatTimeAll(ms) ch1axAng ch2axAng  para1a para1b para1c para1d  para2a para2b para2c para2d
clickBtimeMs = corValArrB(:,1); % ms, tider for Beat
cntArr525 = makeCntArr525(corValArrB);
plotCurves(musArr525, corArrDB, cntArr525, clickDBtimeMs, clickBtimeMs, corValArrB, gu.startClickNr,  gu.endClickNr, -1, -1);



%%


% 16 stk - movGen, DB type

selectedMovNr[] % 3 stk

copy alle 3 til 16 movGen

permute eksisterende vals

Permute remove vals
permute add new rand vals

cross


plotCurves(musArr525, corArrDB, cntArr525, clickDBtimeMs, clickBtimeMs, corValArrB, 77,  88, workDir, 'start');
gui
%%






corArrDB = {};
for i = 1 : length(corStrArr)
    corArrDB(i,:) = {str2double(corStrArr(i,1)), corStrArr(i,3), corStrArr(i,4), corStrArr(i,5)};
end

for i = 1:length(corArrDB)
    corArrDB{i,2} = "";
end


fi = fopen('co.txt','w');

for i = 1 : length(corArr)
    c = '                                                                                      ';
    % fprintf(fi, '%d \t \t %s \t \t %s \t \t %s \n', cor{i,1}, cor{i,2}, cor{i,3}, cor{i,4} );
    
    c(1:length(num2str(cor{i,1}))) = num2strcor{i,1};
end

fclose(fi);