// Starter ved "." over serial

#include <SPI.h>
#include <SD.h>

const int chipSelect = 8;
File txtFile;

int kjor = 0;
double teller = 0;
int b = 0;
int d = 0;

double F = 290; // Servo refresh Hz
double T = 1 / F; // Rundetid if loop, 0.0034 sec
double offsett = -75; // servo offset

void setup()
{
  pinMode(10, OUTPUT); // Skal stå 8?
  digitalWrite(10, HIGH); // Skal stå 8?
  pinMode(3, OUTPUT); // servo PWM
  teller = 0;
  delay(1000);
  Serial.begin(9600);
  delay(1000);
  kjor = 0;

  while (!Serial)
    ; // wait for serial port to connect. Needed for native USB port only

  if (!SD.begin(chipSelect))
  {
    Serial.println("Card failed, or not present");
    while (1); // don't do anything more:
  }
}

void loop() // en runde tar T us eller 3.4483e+03us
{
  if (Serial.available() > 0)
  {
    b = Serial.read();
    if (b == 46) // "."
      kjor = 1;
  }

  if (kjor == 1)
  {
    txtFile = SD.open("1.txt");
    if (txtFile)
    {
      d = txtFile.parseInt(); // grums
      while (txtFile.available()) // SD loopen
      {
        teller++;
        d = txtFile.parseInt();
        
        PORTD = PORTD | B00001000; //digitalWrite(3, 1);
        delayMicroseconds(d);

        PORTD = PORTD & B11110111; //digitalWrite(3, 0);
        delayMicroseconds(1000000 * T - d);
      }
    }
    else
      Serial.println("error opening 1.txt");

    txtFile.close();  
    kjor = 0;
  }

}
